#include <bits/stdc++.h>
#define ll long long
#define ff irst
#define ss second
#define pb push_back
#define mp make_pair

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, q, k;
    cin >> n >> q >> k;
    vector<int> p(n);
    vector<int> ans(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
        ans[i] = i + 1;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        vector<pair<int, int> > a(r - l + 1);
        for (int i = 0; i < r - l + 1; ++i)
            a[i] = {p[i], ans[i + l]};
        sort(a.begin(), a.end());
        for (int i = l; i < r + 1; ++i)
            ans[i] = a[i - l].second;
    }
    cout << ans[k - 1];
    return 0;
}
